* Mountains plot ;

* inds= ް ;
* xh=   ̑ڐ̊Ԋu ;
* id=   ̽:1=ؽ or 2=ΐޔ or 3=ޔ ;

%macro mountain(inds,xh,id);
*{ް;
data ds10; set &inds;
%if &id=1 %then %do;
  p1=c/(a+c); p2=d/(b+d);
  ym=p1-p2; ysd=sqrt(p1*(1-p1)/(a+c)+p2*(1-p2)/(b+d)); YPR=1/YSD;
  %end;
%if &id=2 or &id=3 %then %do;
  ym=log((b*c)/(a*d)); ysd=sqrt(1/a+1/b+1/c+1/d); YPR=1/YSD;
  %end;
  keep study ym ysd ypr ref;
run;

*****{ްĂ̕ϐ;
* STUDY: ިԍiserial No.j;
* YM:    ؽ or ޔ;
* YSD:   YM̕W΍;
* ref:   ި or p;

*ި̫ϯď;
data ylabel; set ds10;
  fmtname='study';
  rename study=start ref=label;
  keep fmtname study ref;
proc format cntlin=ylabel; run;

*ިi޻ްݐj;
data _null_; set ds10 nobs=studyn;
  call symput('sn',studyn);
run;

*ۯėpް;
PROC SORT DATA=ds10; BY DESCENDING Ypr;
DATA DS20; SET DS10;
  RETAIN YSDMAX 0;
  IF YSDMAX < YPR THEN YSDMAX=YPR;
PROC SORT DATA=DS20; BY DESCENDING STUDY;
DATA DS30; SET DS20;
  RETAIN YYMAX 0;
  IF YYMAX < STUDY THEN YYMAX=STUDY;
DATA DS40; SET DS30;
  RETAIN HH 2;
  x95=1.96*ysd;
  X1=x95*2/1000; Y1=HH/YSDMAX;
  PAI=3.14;
  Y=STUDY;
  X=YM-x95; %if &id=3 %then %str(X=exp(YM-x95);); OUTPUT;
  X=YM+x95; %if &id=3 %then %str(X=exp(YM+x95);); OUTPUT;
  X=YM;     %if &id=3 %then %str(X=exp(YM););     OUTPUT;
  DO S=0 TO 500;
    IF S=0 THEN X=YM;
    else X=YM-X1*S;
    Y=STUDY+(1/(SQRT(2*PAI)*YSD)*EXP(-(X-YM)**2/(2*YSD**2)))*Y1;
    %if &id=3 %then %str(x=exp(x););
    OUTPUT ;
    END;
  DO S=0 TO 1000;
    X=YM-x95+X1*S;
    Y=STUDY+(1/(SQRT(2*PAI)*YSD)*EXP(-(X-YM)**2/(2*YSD**2)))*Y1;
    %if &id=3 %then %str(x=exp(x););
    OUTPUT ;
    END ;
RUN ;

*͈̔;
proc summary data=ds40;
  var x; output out=orderl min=min max=max;
data _null_; set orderl;
  rl=(int(max/&xh)+1)*&xh; call symput('rl',rl);
  if min<0 then min=min-&xh;
  ll=(int(min/&xh))*&xh;   call symput('ll',ll);
run;

*ۯ;
goptions gunit=cm ftext=swissb;
%macro href;
  %if &id=1 or &id=2 %then %str(href=0 );
  %if &id=3          %then %str(href=1 );
%mend href;
%do i=1 %to &sn;
  SYMBOL&i C=black INTERPOL=JOIN HEIGHT=1 w=3;
%end;
AXIS1 ORDER=1 TO %eval(&sn+1) BY 1 MINOR=NONE major=none label=none
      VALUE=(F=SWISS H=0.5 t=%eval(&sn+1) '');
AXIS2 label=none VALUE=(F=SWISS H=0.5)
      ORDER=&ll TO &rl BY &xh;
%if &id=1 %then %str(footnote "Risk Difference";);
%if &id=2 %then %str(footnote "Log Odds Ratio";);
%if &id=3 %then %str(footnote "Odds Ratio";);
PROC GPLOT DATA=DS40 ;
  PLOT Y*X=STUDY / NOLEGEND VAXIS=AXIS1 HAXIS=AXIS2 %href;
  format y study.;
RUN ; footnote; quit;
%mend mountain;

DATA DS00;
  length ref $40;
  INPUT STUDY a b c d ref;
DATALINES;
 1  37  42  2  1 Chaopra et al.
 2  40  40  4  4 Mogensen
 3 101 106  6  4 Pitt et al.
 4  96  95  7  5 Darby et al.
 5 103 103  7  3 Bennett et al.
 6 143 142 11  4 O'Brian et al.
 ;
RUN;
*****ްĂ̕ϐ;
* STUDY: ިԍiserial No.j;
* a:     ÁFL;
* b:     ΏƎÁFL;
* c:     ÁF;
* d:     ΏƎÁF;
* ref:   ި or p;

options mprint;
%mountain(ds00, 0.04,1);
%mountain(ds00, 1   ,2);
%mountain(ds00,10   ,3);
